if(ForceRequiredAddon("Weapon_SWeps") == $Error::AddOn_NotFound)
	return;
AddDamageType("PistolSilenced",'<bitmap:Add-Ons/Weapon_SWeps_SilPistol/ci_pistol_silenced> %1','%2 <bitmap:Add-Ons/Weapon_SWeps_SilPistol/ci_pistol_silenced> %1',0.2,1);
datablock AudioProfile(pistolSilencedFireSound)
{
	filename    = "./pistol_silencedFire.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock ProjectileData(pistolSilencedProjectile : gunProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	directDamage        	= 20;
	explosion 				= pistolExplosion;
	directDamageType    	= $DamageType::PistolSilenced;
	radiusDamageType    	= $DamageType::PistolSilenced;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	sProjectile = 1;
	sDamageFalloff = 0.8;
	sDamageFalloffRatio = 0.6;
};
datablock ItemData(pistolSilencedItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "secondary";

	shapeFile = "./pistol_silenced.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Pistol Silenced";
	iconName = "./icon_pistol_silenced";
	fakeIcon = pistolIcon;
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.4 1";
	ammo = 1;
	canPutInSuitcase = 1;

	image = pistolSilencedImage;
	canDrop = true;
	
	sAmmoType = "9mm";
	sAmmo = 12;
	sHeat = 15;
};
datablock ShapeBaseImageData(pistolSilencedImage)
{
	className = "WeaponImage";
	shapeFile = "./pistol_silenced.dts";
	emap = true;
	mountPoint = 0;
	offset = "-0.014 0.05 -0.02";
	item = pistolSilencedItem;
	ammo = " ";
	projectile = pistolSilencedProjectile;
	projectileType = Projectile;
	
	casing = shell9mmDebris;
	shellExitDir        = "1.14 -0.7 0.2";
	shellExitDir        = "1.2 -1.3 0.5";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	
	eyeOffset = 0;
	
	doColorShift = true;
	colorShiftColor = pistolSilencedItem.colorShiftColor;
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.3;
	stateTransitionOnTimeout[0] 	= "Idle";
	
	stateName[1]					= "Idle";
	stateTransitionOnNotLoaded[1]	= "UnloadA";
	stateTransitionOnTriggerDown[1]	= "Trigger";
	
	stateName[2]					= "Trigger";
	stateScript[2]					= "onTrigger";
	stateTimeoutValue[2]			= 0.02;
	stateSequence[2]				= "trig";
	stateTransitionOnTimeout[2]		= "FireCheckA";
	
	stateName[3]					= "FireCheckA";
	stateScript[3]					= "onFireCheck";
	stateTimeoutValue[3]			= 0.01;
	stateTransitionOnTimeout[3]		= "FireCheckB";
	
	stateName[4]					= "FireCheckB";
	stateTransitionOnAmmo[4]		= "Fire";
	stateTransitionOnNoAmmo[4]		= "DryFire";
	
	stateName[5]					= "Fire";
	stateScript[5]					= "onFire";
	stateEmitter[5]					= gunSmokeEmitter;
	stateEmitterTime[5]				= 0.05;
	stateFire[5]					= true;
	stateEjectShell[5]				= true;
	stateSequence[5]				= "fire";
	stateEmitterNode[5]				= "muzzlePoint";
	stateTransitionOnTimeout[5]     = "Release";
	stateTimeoutValue[5]            = 0.12;
	
	stateName[6]					= "Release";
	stateScript[6]					= "onRelease";
	stateTransitionOnTriggerUp[6]	= "Wait";
	
	stateName[7]					= "Wait";
	stateTimeoutValue[7]			= 0.18;
	stateTransitionOnTimeout[7]		= "Idle";
	
	stateName[8]					= "UnloadA";
	stateSequence[8]				= "unload";
	stateTimeoutValue[8]			= 0.01;
	stateScript[8]					= "onUnload";
	stateTransitionOnTimeout[8]		= "UnloadB";
	
	stateName[9]					= "UnloadB";
	stateTimeoutValue[9]			= 0.7;
	stateTransitionOnTimeout[9]	= "ReloadA";
	
	stateName[10]					= "ReloadA";
	stateSequence[10]				= "reload";
	stateTimeoutValue[10]			= 0.01;
	stateScript[10]					= "onReloadA";
	stateTransitionOnTimeout[10]	= "ReloadB";
	
	stateName[11]					= "ReloadB";
	stateTimeoutValue[11]			= 0.25;
	stateTransitionOnTimeout[11]	= "ReloadC";
	
	stateName[12]					= "ReloadC";
	stateScript[12]					= "onReloadB";
	stateTimeoutValue[12]			= 0.1;
	stateTransitionOnTimeout[12]	= "Idle";
	
	stateName[13]					= "DryFire";
	stateSequence[13]				= "dryfire";
	stateScript[13]					= "onDryFire";
	stateTransitionOnTimeout[13]     = "Release";
	stateTimeoutValue[13]            = 0.12;
};
function pistolSilencedImage::onFire(%db,%pl,%slot)
{
	if(%pl.getDamagePercent() >= 1)
		return;
	%pl.playThread(2,plant);
	serverPlay3D(pistolSilencedFireSound,%pl.getPosition());
	
	%pl.sAmmo_heat[%db] = mClamp(%pl.sAmmo_heat[%db]+1,0,%db.item.sHeat);
	sAmmo_fire(%db,%pl,%slot,0.005+((%pl.sAmmo_heat[%db]/%db.item.sHeat)*0.035),180,1);
	cancel(%pl.sAmmoCooldownHeatSched[%db]);
	%pl.sAmmoCooldownHeatSched[%db] = %pl.schedule(200,sAmmo_heatCooldown,%db,%slot);
	
	%val = sAmmo_dec(%db,%pl,%slot);
	if(!sAmmo_check(%db,%pl,%slot))
		serverPlay3D(mac10LastRoundSound,%pl.getPosition());
		
	if(getSimTime()-%pl.lastShellSound > 400 || getRandom(0,1) == 0)
	{
		%pl.lastShellSound = getSimTime();
		if(isObject(%cl = %pl.client))
			%cl.play3D(small_bulletDrop @ getRandom(1,5) @ Sound,%pl.getPosition());
	}
	if(%val == 0)
		%pl.setImageAmmo(%slot,0);
}
function pistolSilencedImage::onFireCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,sAmmo_check(%db,%pl,%slot));
}
function pistolSilencedImage::onTrigger(%db,%pl,%slot)
{
	if(isObject(%cl = %pl.client))
		%cl.play3D(mac10TrigSound,%pl.getPosition());
}
function pistolSilencedImage::onDryFire(%db,%pl,%slot)
{
	%pl.sAmmo_warn = "warn";
	%pl.sAmmo_warnMax = 150;
	%pl.sAmmo_lastWarn = getSimTime();
	sAmmo_display(%pl);
}
function pistolSilencedImage::onUnload(%db,%pl,%slot)
{
	sAmmo_display(%pl,0);
	%up = %pl.getUpVectorHack();
	%forward = %pl.getEyeVectorHack();
	
	%p = new projectile()
	{
		datablock = pistolClipProjectile;
		initialPosition = vectorAdd(%pl.getMuzzlePoint(%slot),vectorRelativeShift(%forward,%up,"-1.6 0 -1.6"));
	};
	%p.explode();
	%pl.playThread(2,shiftTo);
	serverPlay3D(pistolUnloadSound,%pl.getPosition());
}
function pistolSilencedImage::onReloadA(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	schedule(20,0,serverPlay3D,pistolLoadSound,%pl.getPosition());
}
function pistolSilencedImage::onReloadB(%db,%pl,%slot)
{
	//%pl.playThread(2,shiftLeft);
	%pl.setImageLoaded(%slot,1);
	sAmmo_reload(%db,%pl,%slot);
}